exec("./prefs.cs");
exec("./2x2.cs");

datablock StaticShapeData(FlatPlaneShape)
{
        category = "Static Shapes";   // Mission editor category
        item = FlatPlaneShape;
        shapeFile = "./plane.dts";
};

function pixelRGBToDec(%color) // Can't be rgbToDec because it has special functions, such as the randomizer
{
	if(getWord(%color, 0) $= "r")
		%c0 = getRandom(0, 255) / 255;
	else
		%c0 = getWord(%color, 0) / 255;

	if(getWord(%color, 1) $= "r")
		%c1 = getRandom(0, 255) / 255;
	else
		%c1 = getWord(%color, 1) / 255;

	if(getWord(%color, 2) $= "r")
		%c2 = getRandom(0, 255) / 255;
	else
		%c2 = getWord(%color, 2) / 255;

	if(getWord(%color, 3) $= "r")
		%c3 = getRandom(0, 255) / 255;
	else
		%c3 = getWord(%color, 3) / 255;

	return %c0 SPC %c1 SPC %c2 SPC %c3;
}

function fxDTSBrick::setPixelColors(%this, %pixel0, %pixel1, %pixel2, %pixel3)
{
	if(%this.dataBlock $= "brick2x2ScreenBrickData")
	{
		if(isObject(%this.pixel[0]) && %pixel0 !$= "" && getWordCount(%pixel0) >= 4)
		{
			if(getWord(%pixel0, 3) <= 0 && getWord(%pixel0, 3) !$= "r")
				%this.pixel[0].hideNode("ALL");
			else if(getWord(%pixel0, 3) !$= "r")
			{
				%color = pixelRGBToDec(%pixel0);

				if(getWord(%color, 3) <= 0)
					%this.pixel[0].hideNode("ALL");
				else
				{
					%this.pixel[0].setNodeColor("ALL", %color);
					%this.pixel[0].unhideNode("ALL");
				}
			}
			else
			{
				%this.pixel[0].setNodeColor("ALL", pixelRGBToDec(%pixel0));
				%this.pixel[0].unhideNode("ALL");
			}
		}

		if(isObject(%this.pixel[1]) && %pixel1 !$= "" && getWordCount(%pixel1) >= 4)
		{
			if(getWord(%pixel1, 3) <= 0 && getWord(%pixel1, 3) !$= "r")
				%this.pixel[1].hideNode("ALL");
			else if(getWord(%pixel1, 3) !$= "r")
			{
				%color = pixelRGBToDec(%pixel1);

				if(getWord(%color, 3) <= 0)
					%this.pixel[1].hideNode("ALL");
				else
				{
					%this.pixel[1].setNodeColor("ALL", %color);
					%this.pixel[1].unhideNode("ALL");
				}
			}
			else
			{
				%this.pixel[1].setNodeColor("ALL", pixelRGBToDec(%pixel1));
				%this.pixel[1].unhideNode("ALL");
			}
		}

		if(isObject(%this.pixel[2]) && %pixel2 !$= "" && getWordCount(%pixel2) >= 4)
		{
			if(getWord(%pixel2, 3) <= 0 && getWord(%pixel2, 3) !$= "r")
				%this.pixel[2].hideNode("ALL");
			else if(getWord(%pixel2, 3) !$= "r")
			{
				%color = pixelRGBToDec(%pixel2);

				if(getWord(%color, 3) <= 0)
					%this.pixel[2].hideNode("ALL");
				else
				{
					%this.pixel[2].setNodeColor("ALL", %color);
					%this.pixel[2].unhideNode("ALL");
				}
			}
			else
			{
				%this.pixel[2].setNodeColor("ALL", pixelRGBToDec(%pixel2));
				%this.pixel[2].unhideNode("ALL");
			}
		}

		if(isObject(%this.pixel[3]) && %pixel3 !$= "" && getWordCount(%pixel3) >= 4)
		{
			if(getWord(%pixel3, 3) <= 0 && getWord(%pixel3, 3) !$= "r")
				%this.pixel[3].hideNode("ALL");
			else if(getWord(%pixel3, 3) !$= "r")
			{
				%color = pixelRGBToDec(%pixel3);

				if(getWord(%color, 3) <= 0)
					%this.pixel[3].hideNode("ALL");
				else
				{
					%this.pixel[3].setNodeColor("ALL", %color);
					%this.pixel[3].unhideNode("ALL");
				}
			}
			else
			{
				%this.pixel[3].setNodeColor("ALL", pixelRGBToDec(%pixel3));
				%this.pixel[3].unhideNode("ALL");
			}
		}
	}
}
registerOutputEvent("fxDTSBrick", "SetPixelColors", "string 64 80\tstring 64 80\tstring 64 80\tstring 32 80");

function serverCmdClearScreens(%client)
{
	if(!%client.isAdmin)
		return;

	%count = missionCleanup.getCount();

	for(%i = %count; %i > 0; %i--)
	{
		%object = missionCleanup.getObject(%i);

		if(%object.dataBlock $= "FlatPlaneShape")
			%object.delete();

	}

	messageAll('MsgClearBricks', "\c3" @ %client.name SPC "\c0cleared all screens.");
}